#!/usr/bin/perl -w
#
# (C) Tony Garnock-Jones, 2000.
# Released under the Perl "Artistic" License:
# http://www.perl.com/language/misc/Artistic.html
#
# $Id: patch.cgi,v 1.4 2000/10/16 02:41:10 tgarnock-jones Exp $

use diagnostics;
use strict;

require "globals.pl";

###########################################################################

sub printPatch($$) {
    my ($id, $fwd) = @_;

    toolbar("<a href=\"transaction.cgi?id=$id\">TRANSACTION&nbsp;$id</a>");

    my $query = $::db->query("select id from transactions where id=$id");
    if (!$query->fetchrow()) {
	print "<h1>Transaction ID $id Not Found</h1>\n";
	return;
    }

    my $direction = $fwd ? "apply" : "undo";

    print <<EOM;
<h1>Patch to $direction transaction ID $id</h1>
<p>
Run this snippet of shell script in your \$DEV_TREE directory to
$direction the changes made to the repository for transaction $id
to your working directory.
</p>
EOM

    print <<EOM;
<h2>Shell Script</h2>
<table border=0 cellspacing=4 cellpadding=2 bgcolor=\#eeeeff width=100%>
<tr><td>
<pre>\#!/bin/sh
\#
\# Automagically-generated patch to $direction CVSzilla transaction ID $id.
\# Run this in your \$DEV_TREE directory.
\#

EOM

    $query = $::db->query("select filepath, oldversion, newversion from transaction_entry " .
			  "where transaction = $id order by filepath");
    my $module = "";
    while (my @row = $query->fetchrow()) {
	my ($filepath, $oldversion, $newversion) = @row;
	my ($newmodule, @filecomponents) = split(/\//, $filepath);
	my $filefragment = join("/", @filecomponents);

	if ($newmodule ne $module) {
	    if ($module) {
		print "cd ..\n";
	    }
	    $module = $newmodule;
	    print "cd $module\n";
	}

	if (!$fwd) {
	    my $tmp = $oldversion;
	    $oldversion = $newversion;
	    $newversion = $tmp;
	}

	print "cvs update -j $oldversion -j $newversion $filefragment\n";
    }

    print <<EOM;
cd ..
</pre>
</td></tr>
</table>
EOM
}

###########################################################################

pageHeader("View Patch");

my %dict = parseQuery();

if (!defined $dict{"id"} || !$dict{"id"} ||
    !defined $dict{"dir"} || !$dict{"dir"}) {
    print "<h1>Invalid arguments</h1>\n";
} else {
    printPatch($dict{"id"}, $dict{"dir"} eq "on");
}

pageFooter();
exit(0);
